//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void wlinks_cycleUsers_reset();
void linkwrapper_environment(int tcp) {
	wlinks_cycleUsers_reset();
	cTcp = tcp;
	if (tcp >= 0) {
		currentLinkType = linkstcp[tcp]->type;
	}else{
		currentLinkType = LINKTYPE_PASSIVE;
	}
}
void wlinks_forward(const unsigned char* line) {
	if (cTcp < 0) {return;}
	sendalllinks_exception(line,cTcp);
}
int wlinks_setLineBufferSize(int len) {
	if (cTcp < 0) {return -1;}
	int tcp = cTcp;
	if (linkstcp[tcp]->linesize == 0) {
		linkstcp[tcp]->linesize = len+1;
		if (linkstcp[tcp]->receivebuffer == NULL && linkstcp[tcp]->type == LINKTYPE_ACTIVE) {
			linkstcp[tcp]->receivebuffer = malloc(linkstcp[tcp]->linesize*2);
			if (linkstcp[tcp]->receivebuffer == NULL) {cTcp = -1;return -1;}
			strcpy(linkstcp[tcp]->receivebuffer,"");
			return 0;
		}
	}
	return 0;
}
bool wlinks_info_needFullInfo() {
#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		return true;
	}
#endif
	return false;
}
unsigned char md5buffer[5][50];
int md5cycle = 0;
const unsigned char* wlinks_md5(const unsigned char* value) {
	md5cycle++;while (md5cycle >= 5) {md5cycle-=5;}
	unsigned char* cpy = malloc(strlen(value)+1);
	if (cpy == NULL) {strcpy(md5buffer[md5cycle],"");return md5buffer[md5cycle];}
	strcpy(cpy,value);
	MDString(cpy);
	free(cpy);
	strcpy(md5buffer[md5cycle],md5result);
	return md5buffer[md5cycle];
}
unsigned char targetbuffer[2];
const unsigned char* wlinks_info_target() {
	if (cTcp < 0) {strcpy(targetbuffer,"");return targetbuffer;}
	if (currentLinkType == LINKTYPE_PASSIVE) {
		return plinks[lt[cTcp]->id]->ip;
	}else{
		return alinks[lt[cTcp]->id]->target;
	}
}
void wlinks_established() {
	if (cTcp < 0) {return;}
	if (lt[cTcp]->established == 1) {return;}
	if (lt[cTcp]->type == LINKTYPE_PASSIVE) {
		int aid = lt[cTcp]->id;
		wlinks_msg("Establishing link to %s:%d (passive)",plinks[aid]->ip,plinks[aid]->port);
	}
	lt[cTcp]->established = 1;
}
const unsigned char* wlinks_info_ownName() {
	return cuo.svd;
}
void wlinks_sendLine(const unsigned char* line,...) {//understands %s %c %d %ld %f %%
	if (cTcp < 0) {return;}
	unsigned char vres[3000] = "";
	unsigned char tmp[51];
	const unsigned char* p;
	va_list ap;
	va_start(ap,line);
	int r = 0;
	while (r < strlen(line)) {
		if (line[r] == '%' && r < strlen(line) - 1) {
			if (line[r + 1] == 's') {
				p = va_arg(ap, char * );
				if (p != NULL) {
					strncat(vres,p,2999);
					vres[2999] = 0;
				}
				r += 2;continue;
			}
			if (line[r + 1] == 'c') {
				if (strlen(vres) < 2998) {
					vres[strlen(vres)+1] = 0;
					vres[strlen(vres)] = (unsigned char)va_arg(ap, int);
				}else{
					int useless = va_arg(ap, int);
				}
				r += 2;continue;
			}
			if (line[r + 1] == 'd') {
				snprintf(&tmp[0],50,"%d",va_arg(ap, int));
				tmp[50] = 0;
				strncat(vres,tmp,2999);
				vres[2999] = 0;
				r += 2;continue;
			}
			if (line[r + 1] == 'l' && r < strlen(line) - 2) {
				if (line[r + 2] == 'd') {
					snprintf(&tmp[0],50,"%ld",va_arg(ap, long));
					tmp[50] = 0;
					strncat(vres,tmp,2999);
					vres[2999] = 0;
					r += 3;continue;
				}
				if (line[r + 2] == 'l' && r < strlen(line) - 3) {
					if (line[r + 3] == 'd') {
						snprintf(&tmp[0],50,"%lld",va_arg(ap, long long));
						tmp[50] = 0;
						strncat(vres,tmp,2999);
						vres[2999] = 0;
						r += 4;continue;
					}
				}
			}
			if (line[r + 1] == 'f') {
				snprintf(&tmp[0],50,"%f",va_arg(ap, double));
				tmp[50] = 0;
				strncat(vres,tmp,2999);
				vres[2999] = 0;
				r += 2;continue;
			}
			if (line[r + 1] == '%') {
				strncat(vres,"%",2999);
				vres[2999] = 0;
				r += 2;continue;
			}
		}
		if (strlen(vres) < 2998) {
			vres[strlen(vres)+1] = 0;vres[strlen(vres)] = line[r];
		}
		r += 1;
	}
	va_end(ap);
	strncat(vres,"\r\n",2999);vres[2999] = 0;
	linkstcp_vsnd(vres,cTcp);
}
void wlinks_msg(const unsigned char* line,...) {//understands %s %c %d %ld %f %%
	if (cTcp < 0) {return;}
	unsigned char vres[3000] = "[LINKS] ";
	unsigned char tmp[51];
	const unsigned char* p;
	va_list ap;
	va_start(ap,line);
	int r = 0;
	while (r < strlen(line)) {
		if (line[r] == '%' && r < strlen(line) - 1) {
			if (line[r + 1] == 's') {
				p = va_arg(ap, char * );
				if (p != NULL) {
					strncat(vres,p,2999);
					vres[2999] = 0;
				}
				r += 2;continue;
			}
			if (line[r + 1] == 'c') {
				if (strlen(vres) < 2998) {
					vres[strlen(vres)+1] = 0;
					vres[strlen(vres)] = (unsigned char)va_arg(ap, int);
				}else{
					int useless = va_arg(ap, int);
				}
				r += 2;continue;
			}
			if (line[r + 1] == 'd') {
				snprintf(&tmp[0],50,"%d",va_arg(ap, int));
				tmp[50] = 0;
				strncat(vres,tmp,2999);
				vres[2999] = 0;
				r += 2;continue;
			}
			if (line[r + 1] == 'l' && r < strlen(line) - 2) {
				if (line[r + 2] == 'd') {
					snprintf(&tmp[0],50,"%ld",va_arg(ap, long));
					tmp[50] = 0;
					strncat(vres,tmp,2999);
					vres[2999] = 0;
					r += 3;continue;
				}
			}
			if (line[r + 1] == 'f') {
				snprintf(&tmp[0],50,"%f",va_arg(ap, double));
				tmp[50] = 0;
				strncat(vres,tmp,2999);
				vres[2999] = 0;
				r += 2;continue;
			}
			if (line[r + 1] == '%') {
				strncat(vres,"%",2999);
				vres[2999] = 0;
				r += 2;continue;
			}
		}
		if (strlen(vres) < 2998) {
			vres[strlen(vres)+1] = 0;vres[strlen(vres)] = line[r];
		}
		r += 1;
	}
	va_end(ap);
	strncat(vres,"\r\n",2999);vres[2999] = 0;
	IOnotice(vres);
}
void wlinks_disconnect() {
	if (cTcp < 0) {return;}
	if (currentLinkType == LINKTYPE_ACTIVE) {
		linkstcp_closeActive(linkstcp[cTcp]->id,0);
	}else{
		linkstcp_closePassive(linkstcp[cTcp]->id);
	}
	cTcp = -1;//we are now disconnected
}
int wlinks_getInt(int index) {
	if (cTcp < 0) {return -1;}
	return linkstcp[cTcp]->plugindata_int[index];
}
void wlinks_setInt(int index, int value) {
	if (cTcp < 0) {return;}
	linkstcp[cTcp]->plugindata_int[index] = value;
}
unsigned char strgetbuf[5];
const unsigned char* wlinks_getStr(int index) {
	if (cTcp < 0) {strcpy(strgetbuf,"");return strgetbuf;}//return an empty string
	if (linkstcp[cTcp]->plugindata_str[index] != NULL) {
		return linkstcp[cTcp]->plugindata_str[index];
	}else{
		strcpy(strgetbuf,"");return strgetbuf;
	}
}
void wlinks_setStr(int index, const unsigned char* value) {
	if (cTcp < 0) {return;}
	if (linkstcp[cTcp]->plugindata_str[index] != NULL) {
		free(linkstcp[cTcp]->plugindata_str[index]);
	}
	linkstcp[cTcp]->plugindata_str[index] = malloc(strlen(value)+1);
	if (linkstcp[cTcp]->plugindata_str[index] != NULL) {
		strcpy(linkstcp[cTcp]->plugindata_str[index],value);
	}
}
const unsigned char* wlinks_info_getPass() {
	if (cTcp < 0) {return NULL;}
	unsigned char* p;
	if (lt[cTcp]->type == LINKTYPE_PASSIVE) {
		p = plinks[lt[cTcp]->id]->password;
	}else{
		p = alinks[lt[cTcp]->id]->password;
	}
	return p;
}
unsigned char shortpass[9];
const unsigned char* wlinks_info_getShortPass() {
	if (cTcp < 0) {return NULL;}
	const unsigned char* p = wlinks_info_getPass();
	if (p != NULL) {
		if (strlen(p) > 8) {
			strncpy(shortpass,p,8);
			shortpass[8] = 0;
			p = shortpass;
		}
	}
	return p;
}
const unsigned char* wlinks_info_getDescription() {
	return cuo.serverdesc;
}
bool wlinks_info_isServicesBot(const unsigned char* nick) {
#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		if (isfakeservicesuser(nick) == true) {
			return true;
		}
	}
#endif
	return false;
}
//server management
int wlinks_addServ(const unsigned char* servname, int hop, const unsigned char* linktarget, const unsigned char* description) {
	if (cTcp < 0) {return;}
	return links_users_addserv(servname, cTcp, hop, linktarget, description);
}
void wlinks_delServ(const unsigned char* servname) {
	if (cTcp < 0) {return;}
	links_users_delserv(servname);
}
bool wlinks_servThroughThisLink(const unsigned char* servname) {
	if (cTcp < 0) {return;}
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			if (strcasecmp(svnames[r],servname) == 0) {
				if (svtcp[r] == cTcp) {return true;}else{return false;}
			}
		}
		r++;
	}
	return false;
}
bool wlinks_servOtherLinked(const unsigned char* servname) {
	if (cTcp < 0) {return;}
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			if (strcasecmp(svnames[r],servname) == 0) {
				if (svtcp[r] != cTcp) {return true;}else{return false;}
			}
		}
		r++;
	}
	return false;
}
bool wlinks_servLinked(const unsigned char* servname) {
	if (cTcp < 0) {return;}
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			if (strcasecmp(svnames[r],servname) == 0) {
				return true;
			}
		}
		r++;
	}
	return false;
}
void wlinks_user_sendWhois(int to, int about) {
	sendwhois(to,about);
}
void wlinks_user_sendServicesWhois(int to, const unsigned char* obot) {
#ifdef SERVICES_ENABLED
	unsigned char bot[40];
	strncpy(bot,obot,39);bot[39] = 0;
	int ok = 0;
	if (cuo.services_activated == 1) {
		if (isfakeservicesuser(bot) == true) {ok = 1;}
	}
	if (ok == 0) {return;}
	writeservicesnick(bot);
	sendserviceswhois(to,bot);
#endif
	return;
}
int wlinks_collideUser(const unsigned char* nickname, long long timestamp) {
#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		if (isfakeservicesuser(nickname) == true) {return -1;}
	}
#endif
	int r = ubn(nickname);
	if (r >= 0) {
		if (up[r]->lastnickchange < timestamp) {
			return -1;
		}else{
			printf("colliding %s with nick change %lld\n",un(r),up[r]->lastnickchange);
			userQuit(r,USERQUIT_COLLISION);
			return 0;
		}
	}else{
		return 0;
	}
}
int wlinks_collideChannel(const unsigned char* nickname, long long timestamp) {
	if (cTcp < 0) {return 0;}
	unsigned char send[500];
	int r = getChanID(nickname);
	if (r >= 0) {
		if (chans[r]->creationtime < timestamp) {
			return -1;
		}else{
			printf("colliding %s with channel creation %lld\n",chans[r]->name,chans[r]->creationtime);
			if (chans[r]->hopcount <= 0) {
			//deop everyone
			
			//tell the new owning server to reset the topic to make sure everyone has it
				snprintf(send,499,":%s RESETTOPIC %s",cuo.svd,chans[r]->name);send[499] = 0;
				sendontcp(send,cTcp);
			}else{
			//send deop event
				snprintf(send,499,":%s DEOP %s",cuo.svd,chans[r]->name);send[499] = 0;
				sendontcp(send,chans[r]->linktcpdata);
			}
			return 0;
		}
	}else{
		return 0;
	}
}
void wlinks_sndMsgToServer(const unsigned char* name,const unsigned char* msg) {
	int r = links_users_servid(name);
	if (r >= 0) {
		sendtoservid(msg,r);
	}
}
void wlinks_pong() {
	if (cTcp < 0) {return;}
	lt[cTcp]->waitingforpong = 0;
	lt[cTcp]->lastping = ts();
}
//channel cycling:
int ccycletype = -1;
int ccycleid = 0;
void wlinks_cycleChannels_start(int type) {
	if (cTcp < 0) {return;}
	ccycleid = -1;
	ccycletype = type;
}
int wlinks_cycleChannels_next() {
	if (ccycletype < 0 || cTcp < 0) {return -1;}
	while (ccycleid < COMPILEOPTION_MAXCHANS - 1) {
		ccycleid++;
		if (chans[ccycleid] != NULL) {
			if (chanusercount(ccycleid) <= 0) {free(chans[ccycleid]);chans[ccycleid] = NULL;continue;}
			if (chans[ccycleid]->hopcount <= 0 || ccycletype != CHANNELCYCLE_LOCAL) {
				if (ccycletype == CHANNELCYCLE_ALLOTHERS) {
					if (chans[ccycleid]->linktcpdata == cTcp) {continue;}
				}
				return ccycleid;
			}
		}
	}
	return -1;
}
void wlinks_cycleChannels_reset() {
	ccycletype = -1;
}
//channel handle info
unsigned char emptychannelname[] = "";
const unsigned char* wlinks_channel_getName(int handle) {
	if (chans[handle] == NULL || cTcp < 0) {return emptychannelname;}
	return chans[handle]->name;
}
int wlinks_channel_getHandle(const unsigned char* c) {
	if (c == NULL || cTcp < 0) {return -1;}
	return getChanID(c);
}
long long wlinks_channel_getTS(int handle) {
	if (chans[handle] == NULL || cTcp < 0) {return -1;}
	return chans[handle]->creationtime;
}
const unsigned char* wlinks_channel_getServer(int handle) {
	if (cTcp < 0) {return NULL;}
	if (chans[handle] == NULL) {return NULL;}
	if (chans[handle]->hopcount <= 0) {return NULL;}//local user
	return chans[handle]->servname;
}
void wlinks_introduceChannelUsers2(int handle, int silent) {
	if (cTcp < 0) {return;}
	if (chans[handle] == NULL) {return;}
	unsigned char cmd[15];strcpy(cmd,"JOIN");
	if (silent == 1) {strcpy(cmd,"SILENTJOIN");}
	unsigned char send[512];
	int r = handle;
	if (chans[r]->hopcount > 0) {
		//introduce all our local users
		int j = 0;
		while (j < userslotcount) {
			if (up[j] != NULL) {
				if (up[j]->pleaseremove == 0 && up[j]->authed == true) {
					if (isuserinchan(j,r) == true) {
						snprintf(send,511,":%s!%s@%s %s %s",up[j]->nickname,up[j]->suserid,up[j]->host,cmd,chans[r]->name);
						send[511] = 0;
						sendontcp(send,cTcp);
					}
				}
			}
			r++;
		}
	}
}
void wlinks_introduceChannelUsers(int handle) {
	wlinks_introduceChannelUsers2(handle,0);
}
void wlinks_introduceChannelUsersSilently(int handle) {
	wlinks_introduceChannelUsers2(handle,1);
}
//del/add channels
void wlinks_addChannel(const unsigned char* nickname, const unsigned char* servername) {
	if (cTcp < 0) {return;}
	links_chans_add(nickname, servername);
}
void setuseridandhost(int handle, const unsigned char* data) {
	unsigned char userid[100];
	strncpy(userid,data,99);userid[99] = 0;
	if (charpos(userid,'!') > 0) {
		cut(userid,charpos(userid,'!')+1);
	}else{return;}
	if (charpos(userid,'@') <= 0) {return;}
	userid[charpos(userid,'@')] = 0;
	unsigned char host[300];
	strncpy(host,data,299);
	host[299] = 0;
	if (charpos(host,'@') <= 0) {return;}
	cut(host,charpos(host,'@')+1);
	if (strlen(host) < 1 || strlen(userid) < 1) {return;}
	strncpy(up[handle]->suserid,userid,COMPILEOPTION_MAXUSERIDLEN);
	up[handle]->suserid[COMPILEOPTION_MAXUSERIDLEN] = 0;
	strncpy(up[handle]->host,host,COMPILEOPTION_MAXHOSTLEN);
	up[handle]->host[COMPILEOPTION_MAXHOSTLEN] = 0;
}
void wlinks_joinUser2(const unsigned char* chan, const unsigned char* actor, int silent) {
	unsigned char nick[80];strncpy(nick,actor,79);nick[79] = 0;
	unsigned char send[500];
	if (cTcp < 0) {return;}
	if (charpos(nick,'!') > 0) {nick[charpos(nick,'!')] = 0;}else{return;}
	
	int c = getChanID(chan);
	if (c < 0) {printf("no such channel: %s\n",chan);return;}
	int u = ubn(nick);
	if (u < 0) {printf("no such user: %s\n",nick);return;}
	
	//add user to the channel
	
	int r = 0;
	int k = -1;
	while (r < COMPILEOPTION_MAXCHANSPERUSER) {
		if (userpointers[u]->chan[r] == NULL) {k = r;break;}
		r += 1;
	}
	if (k < 0) {return;} //no chan slot left
	up[u]->chan[k] = malloc(sizeof(struct weircd_user_chaninfo));
	if (up[u]->chan[k] == NULL) {
		//mem allocation failed
		return;
	}
	memset(up[u]->chan[k],0,sizeof(struct weircd_user_chaninfo));
	up[u]->chan[k]->chanid = r;
	up[u]->chan[k]->iamop = false;
	up[u]->chan[k]->iamhalfop = false;
	up[u]->chan[k]->iamvoice = false;
	up[u]->chan[k]->iamprotected = false;
	printf("channel created\n");
	//send join event to all the local users (including the user itself if he/she is local)
	
	if (silent == 0) {
	snprintf(send,499,":%s JOIN %s",actor,chans[c]->name);
	send[499] = 0;
	tellallusersinchan_local(send,c);
	}
	
	setuseridandhost(u,actor); //send user id and host from the available data
}
void wlinks_joinUser(const unsigned char* chan, const unsigned char* actor) {
	wlinks_joinUser2(chan, actor, 0);
}
void wlinks_joinUserSilently(const unsigned char* chan, const unsigned char* actor) {
	wlinks_joinUser2(chan, actor, 1);
}
void wlinks_delChan(const unsigned char* chan) {
	if (cTcp < 0) {return;}
	int id = getChanID(chan);
	if (id < 0) {return;}
	links_chans_del(id);
}
void wlinks_channelMsg(const unsigned char* chan, const unsigned char* msgline) {
	if (cTcp < 0) {return;}
	int c = getChanID(chan);
	if (c < 0) {return;}
	tellallusersinchan_local(msgline,c);
}
void wlinks_processJoin(const unsigned char* chan, const unsigned char* actor, const unsigned char* password) {
	printf("attempting to join %s -> %s\n",actor,chan);
	unsigned char nick[80];strncpy(nick,actor,79);nick[79] = 0;
	unsigned char send[500];
	if (cTcp < 0) {return;}
	if (charpos(nick,'!') > 0) {nick[charpos(nick,'!')] = 0;}else{return;}
	printf("nick is %s\n",nick);
	int c = getChanID(chan);
	if (c < 0) {return;}
	int u = ubn(nick);
	if (u < 0) {return;}
	
	printf("setting userid and host\n");
	setuseridandhost(u,actor);
	printf("moving %s into chan\n",up[u]->nickname);
	moveintochan(u,chan);
}
void wlinks_partUser(const unsigned char* chan, const unsigned char* actor, const unsigned char* reason) {
	unsigned char nick[80];strncpy(nick,actor,79);nick[79] = 0;
	unsigned char send[500];
	if (cTcp < 0) {return;}
	if (charpos(nick,'!') > 0) {nick[charpos(nick,'!')] = 0;}else{return;}
	
	int c = getChanID(chan);
	if (c < 0) {return;}
	int u = ubn(nick);
	if (u < 0) {return;}
	
	setuseridandhost(u,actor);
	
	moveoutofchan(u,chan,reason);
}
//user cycling:
int cycletype = -1;
int cycleid = 0;
void wlinks_cycleUsers_start(int type) {
	if (cTcp < 0) {return;}
	cycleid = -1;
	cycletype = type;
}
int wlinks_cycleUsers_next() {
	if (cycletype < 0 || cTcp < 0) {return -1;}
	while (cycleid < COMPILEOPTION_MAXUSERS - 1) {
		cycleid++;
		if (up[cycleid] != NULL) {
			if (up[cycleid]->pleaseremove == 0 && up[cycleid]->authed == true) {
				if (up[cycleid]->hopcount <= 0 || cycletype != USERCYCLE_LOCAL) {
					if (cycletype == USERCYCLE_ALLOTHERS) {
						if (up[cycleid]->linktcpdata == cTcp) {continue;}
					}
					return cycleid;
				}
			}
		}
	}
	return -1;
}
void wlinks_cycleUsers_reset() {
	cycletype = -1;
}
//server cycling
int scycleid = -2;
void wlinks_cycleServers_start() {
	if (cTcp < 0) {return;}
	scycleid = -1;
}
int wlinks_cycleServers_next() {
	if (cTcp < 0 || scycleid < -1) {return -1;}
	while (scycleid < MAXSERVS) {
		scycleid++;
		if (svnames[scycleid] != NULL && svtcp[scycleid] != cTcp) {
			return scycleid;
		}
	}
	return -1;
}
const unsigned char* wlinks_cycleServers_getName(int handle) {
	return svnames[handle];
}
const unsigned char* wlinks_cycleServers_getLinkTarget(int handle) {
	return svlinked[handle];
}
const unsigned char* wlinks_cycleServers_getDesc(int handle) {
	return svdesc[handle];
}
int wlinks_cycleServers_hopcount(int handle) {
	return svhop[handle];
}
//user infos:
const unsigned char* wlinks_user_getServer(int handle) {
	if (cTcp < 0) {return NULL;}
	if (up[handle] == NULL) {return NULL;}
	if (up[handle]->pleaseremove == 1 || up[handle]->authed == false) {return NULL;}
	if (up[handle]->hopcount <= 0) {return NULL;}//local user
	return up[handle]->servname;
}
const unsigned char* wlinks_user_getNickname(int handle) {
	if (cTcp < 0) {return NULL;}
	if (up[handle] == NULL) {return NULL;}
	if (up[handle]->pleaseremove == 1 || up[handle]->authed == false) {return NULL;}
	return up[handle]->nickname;
}
long long wlinks_user_getTS(int handle) {
	if (cTcp < 0) {return ts();}
	if (up[handle] == NULL) {return ts();}
	if (up[handle]->pleaseremove == 1 || up[handle]->authed == false) {return ts();}
	return up[handle]->lastnickchange;
}
int wlinks_user_getHandle(const unsigned char* nick) {
	return ubn(nick);
}
void wlinks_sndMsgToUser(const unsigned char* nick,const unsigned char* msg) {
	if (cTcp < 0) {return;}
	int r = ubn(nick);
	if (r >= 0) {
		if (up[r]->hopcount <= 0) {
			vsnd(msg,r);
		}else{
			sendonlink(msg,r);
		}
	}
}
void wlinks_sendTopic(const unsigned char* chan, const unsigned char* user) {
	if (cTcp < 0) {return;}
	int k = getChanID(chan);
	int u = ubn(user);
	if (k < 0 || u < 0) {return;}
	if (chans[k]->hopcount > 0) {return;}
	sendtopic(u,k);
}
bool wlinks_channelContainsUser(const unsigned char* chan, const unsigned char* user) {
	if (cTcp < 0) {return;}
	int k = getChanID(chan);
	int u = ubn(user);
	if (k < 0 || u < 0) {return;}
	if (chans[k]->hopcount > 0 && up[u]->hopcount > 0) {return;}
	return isuserinchan(u,k);
}
void wlinks_sendNamesToUser(const unsigned char* chan, const unsigned char* user) {
	if (cTcp < 0) {return;}
	int k = getChanID(chan);
	int u = ubn(user);
	if (k < 0 || u < 0) {return;}
	if (chans[k]->hopcount > 0) {return;}
	sendchanusers(u,k);
}
bool wlinks_user_throughThisLink(int handle) {
	if (cTcp < 0) {return;}
	if (up[handle] == NULL) {return false;}
	if (up[handle]->pleaseremove == 1 || up[handle]->authed == false) {return false;}
	if (up[handle]->hopcount <= 0) {return false;}
	if (up[handle]->linktcpdata == cTcp) {return true;}
	return false;
}
//del/add users:
void wlinks_addUser(const unsigned char* nickname, const unsigned char* servername) {
	if (cTcp < 0) {return;}
	links_users_add(nickname, servername);
}
void wlinks_renameUser(const unsigned char* oldnick, const unsigned char* newnick) {
	if (cTcp < 0) {return;}
	int r = ubn(oldnick);
	if (r >= 0) {
		strncpy(up[r]->nickname,newnick,COMPILEOPTION_MAXNICKLEN);
		up[r]->nickname[COMPILEOPTION_MAXNICKLEN] = 0;
	}
}
void wlinks_removeUser(const unsigned char* nick, const unsigned char* reason) {
	if (cTcp < 0) {return;}
	int r = ubn(nick);
	if (r >= 0) {
		up[r]->quitreason = malloc(strlen(reason)+1);
		if (up[r]->quitreason != NULL) {
			strcpy(up[r]->quitreason,reason);
		}
		userQuit(r,USERQUIT_ERROR);
	}
}

