//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

int conf_rehash = 0;
int cwarning(const unsigned char* content,int line) {
	unsigned char mystringle_replace[700];
	if (conf_rehash == 0) {
		if (line >= 0) {
			printf("Warning while parsing config file: Error in line %d: %s\n",line,content);
		}else{
			printf("Warning while loading config/additional files: %s\n",content);
		}
	}else{
		strcpy(mystringle_replace,"\0");
		if (line >= 0) {
			sprintf(&mystringle_replace[0],"[CONFIG] Warning while parsing config file: Error in line %d: %s",line,content);
		}else{
			sprintf(&mystringle_replace[0],"[CONFIG] Warning while loading config/additional files: %s",content);
		}
		IOnotice(mystringle_replace);
	}
	return;
}
int cerr(const unsigned char* content,int line) {
	unsigned char mystringle_replace[700];
	if (conf_rehash == 0) {
		if (line >= 0) {
			printf("%s    > Parsing config failed: Error in line %d:\n%s        %s\n",startupprefixsub,line,startupprefixsub,content);
		}else{
			printf("%s    > Error while loading config/additional files:\n%s        %s\n",startupprefixsub,startupprefixsub,content);
		}
	}else{
		strcpy(mystringle_replace,"\0");
		if (line >= 0) {
			sprintf(&mystringle_replace[0],"[CONFIG] Parsing config failed: Error in line %d: %s",line,content);
		}else{
			sprintf(&mystringle_replace[0],"[CONFIG] Error while loading config/additional files: %s",content);
		}
		IOnotice(mystringle_replace);
	}
	return;
}
unsigned char vfileerror[500];
void tellfileerror() {
#ifndef WIN
	if (errno == EPERM || errno == EACCES) {
		strcpy(vfileerror,"no permission");return;
	}
	if (errno == ENOENT || errno == EFAULT || errno == ENODEV) {
		strcpy(vfileerror,"file not found!");return;
	}
	if (errno == EISDIR) {
		strcpy(vfileerror,"target is a directory");return;
	}
	if (errno == EBUSY) {
		strcpy(vfileerror,"device is busy");return;
	}
	if (errno == ETXTBSY) {
		strcpy(vfileerror,"blocked because of other read/write operation (likely of another program)");return;
	}
	if (errno == EMFILE || errno == ENFILE) {
		strcpy(vfileerror,"too many files are already opened");return;
	}
#endif
#ifdef WIN
	int err = GetLastError();
	if (err == ERROR_ACCESS_DENIED || err == ERROR_INVALID_ACCESS || err == ERROR_WRITE_PROTECT) {
		strcpy(vfileerror,"no permission");return;
	}
	if (err == ERROR_FILE_NOT_FOUND || err == ERROR_PATH_NOT_FOUND) {
		strcpy(vfileerror,"file not found!");return;
	}
	if (err == ERROR_NOT_READY || err == ERROR_WRITE_FAULT || err == ERROR_SHARING_BUFFER_EXCEEDED || err == ERROR_HANDLE_DISK_FULL || err == ERROR_NETWORK_BUSY || err == ERROR_OUT_OF_STRUCTURES) {
		strcpy(vfileerror,"device is busy");return;
	}
	if (err == ERROR_SHARING_VIOLATION || err == ERROR_LOCK_VIOLATION) {
		strcpy(vfileerror,"blocked because of other read/write operation (likely of another program)");return;
	}
	if (err == ERROR_TOO_MANY_OPEN_FILES) {
		strcpy(vfileerror,"too many files are already opened");return;
	}
#endif
	strcpy(vfileerror,"unknown error");return;
}
int currentlinkblock = -1;
int newlinkblock() {
	currentlinkblock++;
	newoptions.links[currentlinkblock] = malloc(sizeof(struct weircd_linkdata));
	if (newoptions.links[currentlinkblock] == NULL) {
		cerr("Out of memory!",-1);
		return -2;
	}
	memset(newoptions.links[currentlinkblock],0,sizeof(struct weircd_linkdata));
	return 0;
}
int expectopeningbracket = 0;
int config_testforblock(unsigned char* line,unsigned char* currblock,const unsigned char* blockname, int linenumber) {
	if (strcasecmp(currblock,"") != 0) {return -1;}
	unsigned char withspace[50];
	strncpy(withspace,blockname,48);withspace[48] = 0;
	strcat(withspace," ");
	if (strcasecmp(line,blockname) == 0 || strstw(line,withspace) == true) {
		if (strstw(line,withspace) == true) {
			cut(line,strlen(withspace));
			trimleft(line);
			if (strstw(line,"{") == false) {
				cerr("Expected '{'",linenumber);
				return -2;
			}else{
				strcpy(currblock,blockname);
				strlwr(currblock);
				cut(line,1);
				expectopeningbracket = 0;
				if (strcasecmp(blockname,"link") == 0) {return newlinkblock();}
				return 0;
			}
		}else{
			strcpy(currblock,blockname);
			strlwr(currblock);
			expectopeningbracket = 1;
			if (strcasecmp(blockname,"link") == 0) {return newlinkblock();}
			return 0;
		}
	}
	return -1;
}
int addreserved(const unsigned char* n, const unsigned char* rs) {
	int r = 0;
	while (r < MAXRESERVEDNICKS) {
		if (newoptions.reservednick[r] == NULL) {
			newoptions.reservednick[r] = malloc(strlen(n)+1);
			if (newoptions.reservednick[r] == NULL) {return -1;}
			if (strlen(rs) > 0) {
				newoptions.reservedreason[r] = malloc(strlen(rs)+1);
				if (newoptions.reservedreason[r] == NULL) {free(newoptions.reservednick[r]);return -1;}
				strcpy(newoptions.reservedreason[r],rs);
			}
			strcpy(newoptions.reservednick[r],n);
			return r;
		}
		r++;
	}
	return -1;
			
}
int addnewconfport(int port) {
	int r = 0;
	while (r < MAXCONFBINDS) {
		if (newoptions.bindport[r] < 0) {
			newoptions.bindport[r] = port;
			return r;
		}
		r++;
	}
	return -1;
}
int readconfig(int IsRehash) {
	if (resetoptions == 0) {resetoptions = 1;memset(&newoptions,0,sizeof(newoptions));memset(&currentoptions,0,sizeof(currentoptions));}
	currentlinkblock = -1;
	conf_rehash = IsRehash;
	if (IsRehash == 0) {
		printf("%s Reading config file...\n",startupprefix);
	}
	FILE *r;
	int k,j;
	int ircopnumber;
	int linenumber;
	char line[300];
	char origline[300];
	char nextline[300];
	char templine[300];
	char linecommand[300];
	char linecommand2[300];
	unsigned char error1[300];
	unsigned char error2[300];
	unsigned char error3[300];
	unsigned char error4[300];
	unsigned char currblock[50] = "";
	unsigned char currsubblock[50] = "";
#ifndef WIN
	r = fopen("weircdconf.cfg","r");
	if (r <= 0) {
		tellfileerror();
		strcpy(error1,"Not able to open ./weircdconf.cfg: ");strcat(error1,vfileerror);
		r = fopen("/etc/weircd/weircdconf.cfg","r");
		if (r <= 0) {
			tellfileerror();
			strcpy(error2,"Not able to open /etc/weircd/weircdconf.cfg: ");strcat(error1,vfileerror);
			r = fopen("/etc/weircdconf.cfg","r");
			if (r <= 0) {
				tellfileerror();
				strcpy(error3,"Not able to open /etc/weircdconf.cfg: ");strcat(error1,vfileerror);
				r = fopen("/usr/weircdconf.cfg","r");
				if (r <= 0) {
					tellfileerror();
					strcpy(error4,"Not able to open /usr/weircdconf.cfg: ");strcat(error1,vfileerror);
					cerr(error1,-1);
					cerr(error2,-1);
					cerr(error3,-1);
					cerr(error4,-1);
					return -1;
				}
			}
		}
	}
#endif
#ifdef WIN
	r = fopen("weircdconf.ini","r");
	if (r <= 0) {
		tellfileerror();
		strcpy(error1,"Not able to open weircdconf.ini: ");strcat(error1,vfileerror);
		cerr(error1,-1);
		return -1;
	}
#endif
	//CLEAR DATA (of new options)
	if (newoptions.serverdomain != NULL) {free(newoptions.serverdomain);newoptions.serverdomain = NULL;}
	if (newoptions.serverdesc != NULL) {free(newoptions.serverdesc);newoptions.serverdesc = NULL;}
	if (newoptions.networkname != NULL) {free(newoptions.networkname);newoptions.networkname = NULL;}
	if (newoptions.bindip != NULL) {free(newoptions.bindip);newoptions.bindip = NULL;}
	if (newoptions.serviceshost != NULL) {free(newoptions.serviceshost);newoptions.serviceshost = NULL;}
	if (newoptions.helpchan != NULL) {free(newoptions.helpchan);newoptions.helpchan = NULL;}
	if (newoptions.motdfilepath != NULL) {free(newoptions.motdfilepath);newoptions.motdfilepath = NULL;}
	if (newoptions.glinefilepath != NULL) {free(newoptions.glinefilepath);newoptions.glinefilepath = NULL;}
	if (newoptions.klinefilepath != NULL) {free(newoptions.klinefilepath);newoptions.klinefilepath = NULL;}
	if (newoptions.vhost_guest != NULL) {free(newoptions.vhost_guest);newoptions.vhost_guest = NULL;}
	if (newoptions.vhost_user != NULL) {free(newoptions.vhost_user);newoptions.vhost_user = NULL;}
	if (newoptions.vhost_admin != NULL) {free(newoptions.vhost_admin);newoptions.vhost_admin = NULL;}
	newoptions.vmaxchansperuser = -1;
	newoptions.nickwaittime = -1;
	newoptions.services_activated = -1;
	newoptions.limitchanchars_activated = -1;
	k = 0;
	while (k < MAXCONFBINDS) {
		newoptions.bindport[k] = -1;
		k++;
	}
	k = 0;
	while (k < MAXOLINECOUNT) {
		if (newoptions.opers[k] != NULL) {free(newoptions.opers[k]);newoptions.opers[k] = NULL;}
		k += 1;
	}
	k = 0;
	while (k < MAXRESERVEDNICKS) {
		if (newoptions.reservednick[k] != NULL) {free(newoptions.reservednick[k]);newoptions.reservednick[k] = NULL;}
		if (newoptions.reservedreason[k] != NULL) {free(newoptions.reservedreason[k]);newoptions.reservedreason[k] = NULL;}
		k += 1;
	}
	k = 0;
	while (k < MAXLINKS) {
		if (newoptions.links[k] != NULL) {
			if (newoptions.links[k]->target != NULL) {free(newoptions.links[k]->target);}
			if (newoptions.links[k]->password != NULL) {free(newoptions.links[k]->password);}
			if (newoptions.links[k]->protocol != NULL) {free(newoptions.links[k]->protocol);}
			free(newoptions.links[k]);
			newoptions.links[k] = NULL;
		}
		k++;
	}
	//READ CONFIG
	linenumber = 0;
	int done = 0;
	while (fgets(line, 300, r) != NULL) {
		strcpy(nextline,"");
		linenumber += 1;
		done = 0;
		while (strcasecmp(line,"") != 0 || strcasecmp(nextline,"") != 0) {
			if (strcasecmp(nextline,"") != 0) {
				strcpy(line,nextline);strcpy(nextline,"");strcpy(linecommand,"");
				done = 1;
			}else{
				if (done == 1) {break;}
				done = 1;
			}
			if (strstw(line,"//") == true) {strcpy(line,"");}
			k = 0;
			j = strlen(line);
			while (k < j - 1) {
				if (line[k] == '/' && line[k+1] == '/') {
					line[k] = 0;
					break;
				}
				k += 1;
			}
			strcpy(line,replacechar(line,13,0));
			strcpy(line,replacechar(line,10,0));
			strcpy(line,replacechar(line,20,0));
			trimleft(line);trimright(line);
			if (charpos(line,';') > 0) {
				allbehindchar(';',nextline,line);
				line[charpos(line,';')] = 0;
				//printf("PARSING:%s\nNEXT:%s\n",line,nextline);
			}else{
				//if (strcasecmp(line,"") != 0) {printf("PARSING %s(NEXT:%s)\n",line,nextline);}
				strcpy(nextline,"");
			}
			if (strcasecmp(currblock,"") == 0) {
				trimleft(line);trimright(line);
				if (config_testforblock(line,currblock,"Server",linenumber) < -2) {fclose(r);return -1;}
				if (config_testforblock(line,currblock,"Services",linenumber) < -2) {fclose(r);return -1;}
				if (config_testforblock(line,currblock,"IrcOps",linenumber) < -2) {fclose(r);return -1;}
				if (config_testforblock(line,currblock,"Link",linenumber) < -2) {fclose(r);return -1;}
				if (config_testforblock(line,currblock,"FloodProtect",linenumber) < -2) {fclose(r);return -1;}
				if (strcasecmp(currblock,"") == 0) {
					if (strlen(line) > 0) {
						cutonfirstspace(line);
						strcpy(linecommand,"'");
						strncat(linecommand,line,59);linecommand[59] = 0;
						cutonfirstspace(linecommand);if (charpos(linecommand,'{') > 0) {cut(linecommand,charpos(linecommand,'{')+1);}
						strcat(linecommand,"' is an unknown block name");
						cerr(linecommand,linenumber);return -1;
					}
				}
			}
			if (strcasecmp(currblock,"") != 0) {
				if (expectopeningbracket == 1) {
					if (line[0] == '{') {
						cut(line,1);
						expectopeningbracket = 0;
					}else{
						cerr("Expected '{'",linenumber);
						return -1;
					}
				}
				trimleft(line);
				if (strlen(line) > 0) {
					if (strcasecmp(line,"}") == 0) {
						if (strcasecmp(currsubblock,"") != 0) {strcpy(currsubblock,"");}else{strcpy(currblock,"");}continue;
					}
parse_new:
					strcpy(origline,line);trimleft(origline);trimright(origline);
					allbeforechar('=',linecommand,line);
					allbehindchar('=',line,line);
					trimleft(line);
					cutonfirstspace(line);
					strcpy(linecommand2,linecommand);
					cutonfirstspace(linecommand);
					if (strcasecmp(currblock,"server") == 0) {
						if (strcasecmp(line,"") != 0 || strcasecmp(linecommand,"") != 0) {
							if (strcasecmp(line,"") == 0) {
								strcpy(line,"Syntax error - no argument for config option '");
								strncat(line,linecommand,109);
								line[109] = 0;
								strcat(line,"' in block '");
								strcat(line,currblock);
								strcat(line,"'");
								cerr(line,linenumber);fclose(r);return -1;
							}
							if (strcasecmp(linecommand,"") == 0) {
								cerr("Syntax error - no option",linenumber);fclose(r);return -1;
							}
						}
						if (strcasecmp(linecommand,"description") == 0) {
							allbehindchar('=',line,origline);
							trimleft(origline);trimright(line);
							if (strlen(line) > 50) {
								cerr("Invalid value - value 'Description' in block 'Server' is too long (max 50 chars)",linenumber);fclose(r);return -1;
							}
							if (strlen(line) < 2) {
								cerr("Invalid value - value 'Description' in block 'Server' is too short (min 2 chars)",linenumber);fclose(r);return -1;
							}
							if (newoptions.serverdesc != NULL) {
								cerr("Value 'Description' in block 'Server' already defined!",linenumber);fclose(r);return -1;
							}
							newoptions.serverdesc = malloc(strlen(line) + 1);
							if (newoptions.serverdesc != NULL) {
								strcpy(newoptions.serverdesc,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"name") == 0) {
							if (strlen(line) > 50) {
								cerr("Invalid value - value 'Name' in block 'Server' is too long (max 50 chars)",linenumber);fclose(r);return -1;
							}
							if (charpos(line,'!') >= 0) {
								cerr("Invalid value - value 'Name' in block 'Server' contains the forbidden character '!'",linenumber);fclose(r);return -1;
							}
							if (newoptions.serverdomain != NULL) {
								cerr("Value 'Name' in block 'Server' already defined!",linenumber);fclose(r);return -1;
							}
							newoptions.serverdomain = malloc(strlen(line) + 1);
							if (newoptions.serverdomain != NULL) {
								strcpy(newoptions.serverdomain,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"motdfile") == 0) {
							if (newoptions.motdfilepath != NULL) {
								cerr("Value 'MOTDfile' in block 'Server' already defined",linenumber);fclose(r);return -1;
							}
							newoptions.motdfilepath = malloc(strlen(line) + 1);
							if (newoptions.motdfilepath != NULL) {
								strcpy(newoptions.motdfilepath,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"glinefile") == 0) {
							if (newoptions.glinefilepath != NULL) {
								cerr("Value 'GLineFile' in block 'Server' already defined",linenumber);fclose(r);return -1;
							}
							newoptions.glinefilepath = malloc(strlen(line) + 1);
							if (newoptions.glinefilepath != NULL) {
								strcpy(newoptions.glinefilepath,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"klinefile") == 0) {
							if (newoptions.klinefilepath != NULL) {
								cerr("Value 'KLineFile' in block 'Server' already defined",linenumber);fclose(r);return -1;
							}
							newoptions.klinefilepath = malloc(strlen(line) + 1);
							if (newoptions.klinefilepath != NULL) {
								strcpy(newoptions.klinefilepath,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"bindip") == 0) {
							if (newoptions.bindip != NULL) {
								cerr("Value 'BindIP' in block 'Server' already defined",linenumber);fclose(r);return -1;
							}
							newoptions.bindip = malloc(strlen(line) + 1);
							if (newoptions.bindip != NULL) {
								strcpy(newoptions.bindip,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"helpchan") == 0) {
							if (strlen(line) > 50) {
								cerr("Invalid value - value 'HelpChan' in block 'Services' is too long (max 50 chars)",linenumber);fclose(r);return -1;
							}
							trimright(line);
							if (charpos(line,32) > 50) {
								cerr("Invalid value - value 'HelpChan' in block 'Services' contains a space char",linenumber);fclose(r);return -1;
							}
							newoptions.helpchan = malloc(strlen(line) + 1);
							if (newoptions.helpchan != NULL) {
								strcpy(newoptions.helpchan,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"network") == 0) {
							if (strlen(line) > 50) {
								cerr("Invalid value - value 'Network' in block 'Server' is too long (max 50 chars)",linenumber);fclose(r);return -1;
							}
							if (charpos(line,' ') > 0) {
								cerr("Invalid value - value 'Network' in block 'Server' contains space chars",linenumber);fclose(r);return -1;
							}
							if (newoptions.networkname != NULL) {
								cerr("Value 'Network' in block 'Server' already defined",linenumber);fclose(r);return -1;
							}
							newoptions.networkname = malloc(strlen(line) + 1);
							if (newoptions.networkname != NULL) {
								strcpy(newoptions.networkname,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"port") == 0) {
							unsigned char attach[5] = "";
							int count = 0;
							while (charpos(line,',') >= 0) {
								strcpy(templine,line);
								templine[charpos(templine,',')] = 0;
								trimright(templine);
								if (strlen(templine) >= 1) {
									count++;
									if (count == 1) {strcpy(attach,"st");}
									if (count == 2) {strcpy(attach,"nd");}
									if (count == 3) {strcpy(attach,"rd");}
									if (count >= 4) {strcpy(attach,"th");}
									if (atoi(templine) < 1 || atoi(templine) > 99999) {
										sprintf(line,"Invalid port value - the %d%s number isn't between 1 and 99999",count,attach);
										cerr(line,linenumber);fclose(r);return -1;
									}
									if (addnewconfport(atoi(templine)) < 0) {
										sprintf(line,"Too many values - maximum is %d",MAXCONFBINDS);
										cerr(line,linenumber);fclose(r);return -1;
									}
								}
								cut(line,charpos(line,',')+1);
							}
							trimleft(line);
							if (strlen(line) >= 1) {
								count++;
								if (count == 1) {strcpy(attach,"st");}
								if (count == 2) {strcpy(attach,"nd");}
								if (count == 3) {strcpy(attach,"rd");}
								if (count >= 4) {strcpy(attach,"th");}
								if (atoi(line) < 1 || atoi(line) > 99999) {
									sprintf(line,"Invalid port value - the %d%s number isn't between 1 and 99999",count,attach);
									cerr(line,linenumber);fclose(r);return -1;
								}
								if (addnewconfport(atoi(line)) < 0) {
									sprintf(line,"Too many values - maximum is %d",MAXCONFBINDS);
									cerr(line,linenumber);fclose(r);return -1;
								}
							}
							if (count <= 0) {
								cerr("Invalid value - no ports specified",linenumber);fclose(r);return -1;
							}
							continue;
						}
						if (strcasecmp(linecommand,"maxchansperuser") == 0) {
							if (atoi(line) < 1 || atoi(line) > COMPILEOPTION_MAXCHANSPERUSER) {
								sprintf(line,"Invalid value - number between 1 and %d expected",COMPILEOPTION_MAXCHANSPERUSER);
								cerr(line,linenumber);fclose(r);return -1;
							}
							newoptions.vmaxchansperuser = atoi(line);
							continue;
						}
					}
					if (strcasecmp(currblock,"link") == 0) {
						if (strcasecmp(line,"") != 0 || strcasecmp(linecommand,"") != 0) {
							if (strcasecmp(line,"") == 0) {
								strcpy(line,"Syntax error - no argument for config option '");
								strncat(line,linecommand,109);
								line[109] = 0;
								strcat(line,"' in block '");
								strcat(line,currblock);
								strcat(line,"'");
								cerr(line,linenumber);fclose(r);return -1;
							}
							if (strcasecmp(linecommand,"") == 0) {
								cerr("Syntax error - no option",linenumber);fclose(r);return -1;
							}
						}
						if (strcasecmp(linecommand,"password") == 0) {
							if (strlen(line) > 64) {
								cerr("Invalid value - value 'Password' in block 'Link' is too long (max 64 chars)",linenumber);fclose(r);return -1;
							}
							trimright(line);
							if (charpos(line,32) > 50) {
								cerr("Invalid value - value 'Password' in block 'Link' contains a space char",linenumber);fclose(r);return -1;
							}
							if (strcasecmp(line,"XXXXXXXXXXXX") == 0) {//it's apparently the default password
								snprintf(line,299,"PLEASE ENTER A PROPER PASSWORD FOR ALL LINKS",newoptions.opers[ircopnumber]->accountname);
								line[299] = 0;
								cerr(line,linenumber);
								fclose(r);
								return -1;
							}
							if (strlen(line) < 12) {
								cerr("Invalid value - value 'Password' in block 'Link' is too short (min 20 chars)",linenumber);fclose(r);return -1;
							}
							
							if (newoptions.links[currentlinkblock]->password != NULL) {
								cerr("Value 'Password' in block 'Link' already defined",linenumber);fclose(r);return -1;
							}
							newoptions.links[currentlinkblock]->password = malloc(strlen(line) + 1);
							if (newoptions.links[currentlinkblock]->password != NULL) {
								strcpy(newoptions.links[currentlinkblock]->password,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"target") == 0) {
							if (strlen(line) > 60) {
								cerr("Invalid value - value 'Target' in block 'Link' is too long (max 60 chars)",linenumber);fclose(r);return -1;
							}
							trimright(line);
							if (charpos(line,32) > 50) {
								cerr("Invalid value - value 'Target' in block 'Link' contains a space char",linenumber);fclose(r);return -1;
							}
							if (newoptions.links[currentlinkblock]->target != NULL) {
								cerr("Value 'Target' in block 'Link' already defined!",linenumber);fclose(r);return -1;
							}
							newoptions.links[currentlinkblock]->target = malloc(strlen(line) + 1);
							if (newoptions.links[currentlinkblock]->target != NULL) {
								strcpy(newoptions.links[currentlinkblock]->target,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"protocol") == 0) {
							if (protocolexists(line) != 0) {
								cerr("Invalid value - value 'Protocol' in block 'Link' is not a supported server-to-server protocol",linenumber);fclose(r);return -1;
							}
							if (strlen(line) > 60) {
								
							}
							trimright(line);
							if (newoptions.links[currentlinkblock]->protocol != NULL) {
								cerr("Value 'Protocol' in block 'Link' already defined",linenumber);fclose(r);return -1;
							}
							newoptions.links[currentlinkblock]->protocol = malloc(strlen(line) + 1);
							if (newoptions.links[currentlinkblock]->protocol != NULL) {
								strcpy(newoptions.links[currentlinkblock]->protocol,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"port") == 0) {
							if (atoi(line) < 1 || atoi(line) > 99999) {
								cerr("Invalid value - number between 1 and 99999 expected",linenumber);fclose(r);return -1;
							}
							newoptions.links[currentlinkblock]->port = atoi(line);
							continue;
						}
						if (strcasecmp(linecommand,"type") == 0) {
							if (strcasecmp(line,"active") != 0 && strcasecmp(line,"passive") != 0) {
								cerr("Unsupported link type",linenumber);fclose(r);return -1;
							}
							if (strcasecmp(line,"active") == 0) {
								newoptions.links[currentlinkblock]->type = LINKTYPE_ACTIVE;
							}
							if (strcasecmp(line,"passive") == 0) {
								newoptions.links[currentlinkblock]->type = LINKTYPE_LISTENER;
							}
							continue;
						}
						
					}
					if (strcasecmp(currblock,"services") == 0) {
						if (strcasecmp(line,"") != 0 || strcasecmp(linecommand,"") != 0) {
							if (strcasecmp(line,"") == 0) {
								strcpy(line,"Syntax error - no argument for config option '");
								strncat(line,linecommand,109);
								line[109] = 0;
								strcat(line,"' in block '");
								strcat(line,currblock);
								strcat(line,"'");
								cerr(line,linenumber);fclose(r);return -1;
							}
							if (strcasecmp(linecommand,"") == 0) {
								cerr("Syntax error - no option",linenumber);fclose(r);return -1;
							}
						}
						if (strcasecmp(linecommand,"host") == 0) {
							if (strlen(line) > 50) {
								cerr("Invalid value - value 'Host' in block 'Services' is too long (max 50 chars)",linenumber);fclose(r);return -1;
							}
							trimright(line);
							if (charpos(line,32) > 50) {
								cerr("Invalid value - value 'Host' in block 'Services' contains a space char",linenumber);fclose(r);return -1;
							}
							if (newoptions.serviceshost != NULL) {
								cerr("Value 'Host' in block 'Services' already defined",linenumber);fclose(r);return -1;
							}
							newoptions.serviceshost = malloc(strlen(line) + 1);
							if (newoptions.serviceshost != NULL) {
								strcpy(newoptions.serviceshost,line);
							}
							continue;
						}
						if (strcasecmp(linecommand,"enabled") == 0) {
							if (strcasecmp(line,"true") != 0 && strcasecmp(line,"false") != 0) {
								cerr("Invalid value - 'true' or 'false' expected",linenumber);fclose(r);return -1;
							}
							if (strcasecmp(line,"true") == 0) {
								newoptions.services_activated = 1;
							}else{
								newoptions.services_activated = 0;
							}
							continue;
						}
						if (strcasecmp(linecommand,"limitchanchars") == 0) {
							if (strcasecmp(line,"true") != 0 && strcasecmp(line,"false") != 0) {
								cerr("Invalid value - 'true' or 'false' expected",linenumber);fclose(r);return -1;
							}
							if (strcasecmp(line,"true") == 0) {
								newoptions.limitchanchars_activated = 1;
							}else{
								newoptions.limitchanchars_activated = 0;
							}
							continue;
						}
						if (strcasecmp(linecommand,"nickwaittime") == 0) {
							if (atoi(line) < 0 || atoi(line) > 6000) {
								cerr("Invalid value - number between 0 and 6000 expected",linenumber);fclose(r);return -1;
							}
							newoptions.nickwaittime = atoi(line);
							continue;
						}
					}
					if (strcasecmp(currblock,"floodprotect") == 0) {
						if (strcasecmp(currsubblock,"") == 0) {
							if (strcasecmp(line,"") == 0) {
								trimleft(linecommand);trimright(linecommand);
								if (config_testforblock(linecommand2,currsubblock,"HostCloaking",linenumber) < -2) {fclose(r);return -1;}
								if (config_testforblock(linecommand2,currsubblock,"ReservedNicks",linenumber) < -2) {fclose(r);return -1;}
							}
							if (strcasecmp(currsubblock,"") != 0) {continue;}
							if (strcasecmp(line,"") != 0 || strcasecmp(linecommand,"") != 0) {
								if (strcasecmp(line,"") == 0) {
									strcpy(line,"'");
									strncat(line,linecommand,109);
									line[109] = 0;
									cutonfirstspace(line);if (charpos(line,'{') > 0) {cut(line,charpos(line,'{')+1);}
									strcat(line,"' is an unknown block name in block '");
									strcat(line,currblock);
									strcat(line,"'");
									cerr(line,linenumber);fclose(r);return -1;
								}
								if (strcasecmp(linecommand,"") == 0) {
									cerr("Syntax error - no option",linenumber);fclose(r);return -1;
								}
							}
							if (strcasecmp(linecommand,"maxconnsperip") == 0) {
								if (atoi(line) < 0 || atoi(line) > COMPILEOPTION_IPSTORAGESIZE / 2) {
									sprintf(&line[0],"Invalid value - number between 1 and %d expected",COMPILEOPTION_IPSTORAGESIZE / 2);
									cerr(line,linenumber);fclose(r);return -1;
								}
								newoptions.maxconnsperip = atoi(line);
								continue;
							}
						}else{
							if (strcasecmp(currsubblock,"hostcloaking") == 0) {
								strcpy(line,linecommand2);
								if (charpos(line,' ') > 0) {cut(line,charpos(line,' ')+1);}else{strcpy(line,"");}
								trimleft(line);cutonfirstspace(line);
								//printf("lc:'%s' lc2:'%s' l:'%s'\n",linecommand,linecommand2,line);
								if (strcasecmp(linecommand,"unregistered") == 0) {
									if (strlen(line) > 50) {
										cerr("Invalid value - host cloak for unregistered users in block 'Server' is too long (max 50 chars)",linenumber);fclose(r);return -1;
									}
									if (charpos(line,' ') > 0) {
										cerr("Invalid value - host cloak for unregistered users in block 'Server' is too long (max 50 chars)",linenumber);fclose(r);return -1;
									}
									if (newoptions.vhost_guest != NULL) {
										cerr("Host cloak for unregistered users in block 'Server' is already defined",linenumber);fclose(r);return -1;
									}
									newoptions.vhost_guest = malloc(strlen(line) + 1);
									if (newoptions.vhost_guest != NULL) {
										strcpy(newoptions.vhost_guest,line);
									}
									continue;
								}
								if (strcasecmp(linecommand,"registered") == 0) {
									if (strlen(line) > 50) {
										cerr("Invalid value - host cloak for registered users in block 'Server' is too long (max 50 chars)",linenumber);fclose(r);return -1;
									}
									if (charpos(line,' ') > 0) {
										cerr("Invalid value - host cloak for registered users in block 'Server' is too long (max 50 chars)",linenumber);fclose(r);return -1;
									}
									if (newoptions.vhost_user != NULL) {
										cerr("Host cloak for registered users in block 'Server' is already defined",linenumber);fclose(r);return -1;
									}
									newoptions.vhost_user = malloc(strlen(line) + 1);
									if (newoptions.vhost_user != NULL) {
										strcpy(newoptions.vhost_user,line);
									}
									continue;
								}
								if (strcasecmp(linecommand,"administrator") == 0) {
									if (strlen(line) > 50) {
										cerr("Invalid value - host cloak for administrators in block 'Server' is too long (max 50 chars)",linenumber);fclose(r);return -1;
									}
									if (charpos(line,' ') > 0) {
										cerr("Invalid value - host cloak for administrators in block 'Server' is too long (max 50 chars)",linenumber);fclose(r);return -1;
									}
									if (newoptions.vhost_admin != NULL) {
										cerr("Host cloak for administrators in block 'Server' is already defined",linenumber);fclose(r);return -1;
									}
									newoptions.vhost_admin = malloc(strlen(line) + 1);
									if (newoptions.vhost_admin != NULL) {
										strcpy(newoptions.vhost_admin,line);
									}
									continue;
								}
							}
							if (strcasecmp(currsubblock,"reservednicks") == 0) {
								//add it to the reserved nicks
								strcpy(line,linecommand2);
								trimright(line);
								if (charpos(line,' ') > 0) {
									strcpy(templine,line);
									line[charpos(line,' ')] = 0;
									cut(templine,charpos(templine,' ')+1);
									trimleft(templine);
								}else{
									strcpy(templine,"");
								}
								if (strlen(line) > 50) {
									cerr("Invalid value - mask for reserved nick is too long (max 50 chars)",linenumber);fclose(r);return -1;
								}
								if (addreserved(line,templine) < 0) {
									cerr("Reserved nicks overflow",linenumber);fclose(r);return -1;
								}
								continue;
							}
						}
					}
					if (strcasecmp(currblock,"ircops") == 0) {
						if (strcasecmp(currsubblock,"") == 0) {
							trimleft(origline);trimright(origline);
							expectopeningbracket = 1;
							strcpy(line,"");
							if (strlen(origline) > 0) {
								if (origline[strlen(origline)-1] == '{') {
									origline[strlen(origline)-1] = 0;
									expectopeningbracket = 0;
								}
							}
							trimright(origline);
							if (charpos(origline,'{') > 0) {
								strcpy(line,origline);
								allbehindchar('{',line,line);
								allbeforechar('}',origline,origline);
								expectopeningbracket = 0;
							}
							if (charpos(origline,' ') > 0 && expectopeningbracket == 1) {
								cutonfirstspace(origline);
								snprintf(&line[0],299,"Expected '{' after '%s' in block 'IrcOps'",origline);
								line[299] = 0;
								cerr(line,linenumber);
								fclose(r);
								return -1;
							}
							cutonfirstspace(origline);
							if (strlen(origline) > 0) {
								if (nicknamevalid(origline) == false) {
									snprintf(&line[0],299,"Invalid oper name '%s'",origline);
									line[299] = 0;
									cerr(line,linenumber);
									fclose(r);
									return -1;
								}
								k = 0;j = -1;
								while (k < MAXOLINECOUNT) {
									if (newoptions.opers[k] == NULL) {
										newoptions.opers[k] = malloc(sizeof(struct oline));
										j = k;
										if (newoptions.opers[k] != NULL) {
											memset(newoptions.opers[k],0,sizeof(struct oline));
											newoptions.opers[k]->accountname = malloc(strlen(origline)+1);
											if (newoptions.opers[k]->accountname != NULL) {
												strcpy(newoptions.opers[k]->accountname,origline);
											}
										}
										break;
									}
									k += 1;
								}
								snprintf(&linecommand[0],299,"CONFIG ERROR: IrcOp block: Failed to add O:Line '%s': Memory allocation failed",origline);
								linecommand[299] = 0;
								if (j < 0) {
									cerr(linecommand,-1);fclose(r);return -1;
								}else{
									if (newoptions.opers[j] == NULL) {
										cerr(linecommand,-1);fclose(r);return -1;
									}else{
										if (newoptions.opers[j]->accountname == NULL) {
											cerr(linecommand,-1);fclose(r);return -1;
										}
									}
								}
								ircopnumber = j;
								strcpy(currsubblock,origline);
							}
							if (strlen(line) > 0) {
								goto parse_new;
							}else{
								continue;
							}
						}
						if (strcasecmp(currsubblock,"") != 0) {
							if (strcasecmp(linecommand,"password") == 0) {
								if (charpos(line,' ') > 0) {
									snprintf(&line[0],299,"The password of IRC op account '%s' contains a space char",newoptions.opers[ircopnumber]->accountname);
									line[299] = 0;
									cerr(line,linenumber);
									fclose(r);
									return -1;
								}
								if (strlen(line) < 4) {
									snprintf(&line[0],299,"The password of IRC op account '%s' is too short",newoptions.opers[ircopnumber]->accountname);
									line[299] = 0;
									cerr(line,linenumber);
									fclose(r);
									return -1;
								}
								if (strcasecmp(line,"XXXX") == 0) {//it's apparently the default password
									snprintf(&line[0],299,"PLEASE ENTER A PROPER PASSWORD FOR O:LINE '%s'!!",newoptions.opers[ircopnumber]->accountname);
									line[299] = 0;
									cerr(line,linenumber);
									fclose(r);
									return -1;
								}
								newoptions.opers[ircopnumber]->password = malloc(strlen(line)+1);
								if (newoptions.opers[ircopnumber]->password == NULL) {
									snprintf(&line[0],299,"CONFIG ERROR: IrcOp block: Failed to set the password of O:Line '%s': Memory allocation failed",newoptions.opers[ircopnumber]->accountname);
									line[299] = 0;
									cerr(line,-1);
									fclose(r);
									return -1;
								}
								strcpy(newoptions.opers[ircopnumber]->password,line);
								continue;
							}
							if (strcasecmp(linecommand,"host") == 0) {
								if (charpos(linecommand,' ') > 0) {
									snprintf(&line[0],299,"The vhost of IRC op account '%s' contains a space char",newoptions.opers[ircopnumber]->accountname);
									line[299] = 0;
									cerr(line,linenumber);
									fclose(r);
									return -1;
								}
								if (strlen(linecommand) < 2) {
									snprintf(&line[0],299,"The vhost of IRC op account '%s' is too short",newoptions.opers[ircopnumber]->accountname);
									line[299] = 0;
									cerr(line,linenumber);
									fclose(r);
									return -1;
								}
								newoptions.opers[ircopnumber]->host = malloc(strlen(linecommand)+1);
								if (newoptions.opers[ircopnumber]->host == NULL) {
									snprintf(&line[0],299,"CONFIG ERROR: IrcOp block: Failed to set the vhost of O:Line '%s': Memory allocation failed",newoptions.opers[ircopnumber]->accountname);
									line[299] = 0;
									cerr(line,-1);
									fclose(r);
									return -1;
								}
								strcpy(newoptions.opers[ircopnumber]->host,linecommand);
								continue;
							}
						}
					}
					strcpy(line,"Unknown config option '");
					strncat(line,linecommand,109);line[109] = 0;
					strcat(line,"' in block '");strcat(line,currblock);strcat(line,"'");
					if (strcasecmp(currsubblock,"") != 0) {
						strcat(line," in sub block '");strcat(line,currsubblock);strcat(line,"'");
					}
					cerr(line,linenumber);
					fclose(r);
					return -1;
				}
			}
			strcpy(line,"");
		}
	}
	fclose(r);
	//CHECK DATA (if something important is missing/not specified)
	if (newoptions.serverdomain == NULL) {
		cerr("CONFIG ERROR: Server block: name option is missing.",-1);return -1;
	}
	if (newoptions.serverdesc == NULL) {
		cerr("CONFIG ERROR: Server block: description value is missing.",-1);return -1;
	}
	if (newoptions.networkname == NULL) {
		cerr("CONFIG ERROR: Server block: network option is missing.",-1);return -1;
	}
	if (newoptions.bindip == NULL) {
		cerr("CONFIG ERROR: Server block: BindIP option is missing.",-1);return -1;
	}
	if (newoptions.helpchan == NULL) {
		cerr("CONFIG ERROR: Server block: HelpChan option is missing.",-1);return -1;
	}
	if (newoptions.glinefilepath == NULL) {
		cerr("CONFIG ERROR: Server block: GlineFile option is missing.",-1);return -1;
	}
	if (newoptions.klinefilepath == NULL) {
		cerr("CONFIG ERROR: Server block: KlineFile option is missing.",-1);return -1;
	}
	k = 0;j = 0;
	while (k < MAXCONFBINDS) {
		if (newoptions.bindport[k] >= 0) {
			j = 1;
			break;
		}
		k++;
	}
	if (j <= 0) {
		cerr("CONFIG ERROR: Server block: port(s) missing.",-1);return -1;
	}
	if (newoptions.vmaxchansperuser <= 0) {
		cerr("CONFIG ERROR: Server block: MaxChansPerUser is missing.",-1);return -1;
	}
	k = 0;
	while (k < MAXLINKS) {
		if (newoptions.links[k] != NULL) {
			if (newoptions.links[k]->type == 0) {
				snprintf(line,299,"CONFIG ERROR: Link block no. %d: Type is missing.",k+1);
				line[299] = 0;
				cerr(line,-1);
				return -1;
			}
			if (newoptions.links[k]->port == 0) {
				snprintf(line,299,"CONFIG ERROR: Link block no. %d: Port is missing.",k+1);
				line[299] = 0;
				cerr(line,-1);
				return -1;
			}
			if (newoptions.links[k]->type == LINKTYPE_ACTIVE && newoptions.links[k]->target == NULL) {
				snprintf(line,299,"CONFIG ERROR: Link block no. %d: Target address is missing.",k+1);
				line[299] = 0;
				cerr(line,-1);
				return -1;
			}
			if (newoptions.links[k]->type == LINKTYPE_PASSIVE && newoptions.links[k]->target != NULL) {
				snprintf(line,299,"CONFIG ERROR: Link block no. %d: Passive links do not support an explicit target!",k+1);
				line[299] = 0;
				cerr(line,-1);
				return -1;
			}
			if (newoptions.links[k]->password == NULL) {
				snprintf(line,299,"CONFIG ERROR: Link block no. %d: Password is missing.",k+1);
				line[299] = 0;
				cerr(line,-1);
				return -1;
			}
			if (newoptions.links[k]->protocol == NULL) {
				snprintf(line,299,"CONFIG ERROR: Link block no. %d: Protocol is missing.",k+1);
				line[299] = 0;
				cerr(line,-1);
				return -1;
			}
		}
		k++;
	}
#ifdef SERVICES_ENABLED
	if (newoptions.serviceshost == NULL) {
		cerr("CONFIG ERROR: Services block: Host option is missing.",-1);return -1;
	}
	if (newoptions.services_activated < 0) {
		cerr("CONFIG ERROR: Services block: Enabled option is missing.",-1);return -1;
	}
	if (newoptions.nickwaittime < 0) {
		cerr("CONFIG ERROR: Services block: NickWaitTime option is missing.",-1);return -1;
	}
	if (newoptions.limitchanchars_activated < 0) {
		cerr("CONFIG ERROR: Services block: LimitChanChars option is missing.",-1);return -1;
	}
#endif
	k = 0;
	while (k < MAXOLINECOUNT) {
		if (newoptions.opers[k] != NULL) {
			if (newoptions.opers[k]->accountname == NULL) {
				cerr("CONFIG ERROR: Fatal error!! O:Line without proper account name found!! (This should NEVER happen)",-1);return -1;
			}
			if (newoptions.opers[k]->password == NULL) {
				snprintf(&line[0],299,"CONFIG ERROR: IrcOp block: O:Line '%s' misses a password",newoptions.opers[k]->accountname);
				line[299] = 0;
				cerr(line,-1);
				return -1;
			}
		}
		k += 1;
	}
#ifndef SERVICES_ENABLED
	if (newoptions.services_activated == 1) {
		cerr("CONFIG ERROR: Services block: services can't be enabled - WeIRCd has been compiled without services support",-1);return -1;
	}
#endif
	//count o:lines and see if we have more than 0
	k = 0;j = 0;
	while (k < MAXOLINECOUNT) {
		if (newoptions.opers[k] != NULL) {j++;}
		k += 1;
	}
	if (j <= 0) {
		cerr("CONFIG ERROR: No IrcOp account present!",-1);return -1;
	}
	
	//NOW TRANSFER ALL THE DATA!
	
	//transfer oper accounts
	k = 0;
	while (k < MAXOLINECOUNT) {
		if (currentoptions.opers[k] != NULL) {free(currentoptions.opers[k]);}
		currentoptions.opers[k] = newoptions.opers[k];
		newoptions.opers[k] = NULL;
		k += 1;
	}
	//transfer bind ports
	k = 0;
	while (k < MAXCONFBINDS) {
		currentoptions.bindport[k] = newoptions.bindport[k];
		k++;
	}
	//free old link data
	k = 0;
	while (k < MAXLINKS) {
		if (currentoptions.links[k] != NULL) {
			if (cuo.links[k]->target != NULL) {free(cuo.links[k]->target);}
			if (cuo.links[k]->password != NULL) {free(cuo.links[k]->password);}
			if (cuo.links[k]->protocol != NULL) {free(cuo.links[k]->protocol);}
			free(currentoptions.links[k]);
			currentoptions.links[k] = NULL;
		}
		k++;
	}
	//transfer link data
	k = 0;
	while (k < MAXLINKS) {
		currentoptions.links[k] = newoptions.links[k];
		newoptions.links[k] = NULL;
		k++;
	}
	//transfer reserved nicks data
	k = 0;
	while (k < MAXRESERVEDNICKS) {
		if (cuo.reservednick[k] != NULL) {
			free(cuo.reservednick[k]);
			if (cuo.reservedreason[k] != NULL) {
				free(cuo.reservedreason[k]);
			}
		}
		cuo.reservednick[k] = newoptions.reservednick[k];
		cuo.reservedreason[k] = newoptions.reservedreason[k];
		newoptions.reservednick[k] = NULL;
		newoptions.reservedreason[k] = NULL;
		k++;
	}
	//transfer various strings
	if (currentoptions.serverdomain != NULL) {free(currentoptions.serverdomain);}currentoptions.serverdomain = newoptions.serverdomain;newoptions.serverdomain = NULL;
	if (currentoptions.serverdesc != NULL) {free(currentoptions.serverdesc);}currentoptions.serverdesc = newoptions.serverdesc;newoptions.serverdesc = NULL;
	if (currentoptions.networkname != NULL) {free(currentoptions.networkname);}currentoptions.networkname = newoptions.networkname;newoptions.networkname = NULL;
	if (currentoptions.bindip != NULL) {free(currentoptions.bindip);}currentoptions.bindip = newoptions.bindip;newoptions.bindip = NULL;
	if (currentoptions.serviceshost != NULL) {free(currentoptions.serviceshost);}currentoptions.serviceshost = newoptions.serviceshost;newoptions.serviceshost = NULL;
	if (currentoptions.helpchan != NULL) {free(currentoptions.helpchan);}currentoptions.helpchan = newoptions.helpchan;newoptions.helpchan = NULL;
	if (currentoptions.motdfilepath != NULL) {free(currentoptions.motdfilepath);}currentoptions.motdfilepath = newoptions.motdfilepath;newoptions.motdfilepath = NULL;
	if (currentoptions.glinefilepath != NULL) {free(currentoptions.glinefilepath);}currentoptions.glinefilepath = newoptions.glinefilepath;newoptions.glinefilepath = NULL;
	if (IsRehash == 1) {saveglines();}
	if (currentoptions.klinefilepath != NULL) {free(currentoptions.klinefilepath);}currentoptions.klinefilepath = newoptions.klinefilepath;newoptions.klinefilepath = NULL;
	if (IsRehash == 1) {saveklines();}
	if (currentoptions.vhost_guest != NULL) {free(currentoptions.vhost_guest);}currentoptions.vhost_guest = newoptions.vhost_guest;newoptions.vhost_guest = NULL;
	if (currentoptions.vhost_user != NULL) {free(currentoptions.vhost_user);}currentoptions.vhost_user = newoptions.vhost_user;newoptions.vhost_user = NULL;
	if (currentoptions.vhost_admin != NULL) {free(currentoptions.vhost_admin);}currentoptions.vhost_admin = newoptions.vhost_admin;newoptions.vhost_admin = NULL;
	//transfer various integers
	currentoptions.vmaxchansperuser = newoptions.vmaxchansperuser;
	currentoptions.nickwaittime = newoptions.nickwaittime;
	currentoptions.services_activated = newoptions.services_activated;
	currentoptions.limitchanchars_activated = newoptions.limitchanchars_activated;
	
	//OK DATA TRANSFER IS DONE
	
	if (IsRehash == 0) {
		printf("%s    > Done\n",startupprefixsub);
	}else{
		IOnotice("[CONFIG] Rehashed.");
	}
	if (currentoptions.motdfilepath != NULL) {
		if (IsRehash == 0) {
			printf("%s    > Loading motd: %s...\n",startupprefixsub,currentoptions.motdfilepath);
		}else{
			snprintf(&line[0],299,"[MOTD] Loading %s...",currentoptions.motdfilepath);
			line[299] = 0;
			IOnotice(line);
		}
		int motdresult = motd_load(currentoptions.motdfilepath);
		if (motdresult < 0) {
			if (IsRehash == 0) {
				printf("%s          -failed!\n",startupprefixsub);
			}else{
				IOnotice("[MOTD] Loading failed!");
			}
		}else{
			if (IsRehash == 0) {
				printf("%s          -done\n",startupprefixsub);
			}else{
				IOnotice("[MOTD] Done.");
			}
		}
	}
	
	if (IsRehash == 1) {//now apply new config options and sync links and listeners to it
		links_checkListeners(0);
		links_checkActive(0);
		listeners_confsync(cuo.bindip,0);
	}
	return 0;
}
