//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#define PROCESSLENGTH 2000
#ifndef WIN
void strlwr(char *s)
{
	while (*s)
	{       *s = tolower(*s);
	s++;
	}
}
#endif
void strupper(char *s)
{
	while (*s)
	{       *s = toupper(*s);
	s++;
	}
}
bool isnumber(const unsigned char* s) {
	if (strlen(s) <= 0) {return false;}
	int r = 0;
	while (r < strlen(s)) {
		if (s[r] < '0' || s[r] > '9') {return false;}
		r++;
	}
	return true;
}
unsigned char spacesbuffer[500];
unsigned char* spaces(int count) {
	memset(&spacesbuffer,0,499);
	int r = 0;
	while (r < count && r < 450) {
		spacesbuffer[r] = ' ';
		r++;
	}
	return spacesbuffer;
}
int stringisinstring(const unsigned char* longstring,const unsigned char* shortstring) {
	char mlongstring[PROCESSLENGTH];strncpy(mlongstring,longstring,PROCESSLENGTH - 2);mlongstring[PROCESSLENGTH - 2] = 0;
	char mshortstring[PROCESSLENGTH];strncpy(mshortstring,shortstring,PROCESSLENGTH - 2);mshortstring[PROCESSLENGTH - 2] = 0;
	int r;
	if (strlen(mlongstring) == 0) {return -1;}
	if (strlen(mshortstring) == 0) {return 0;}
	if (strlen(mshortstring) > strlen(mlongstring)) {return -1;}
	if (strlen(mshortstring) == strlen(mlongstring) && strcmp(mlongstring,mshortstring) != 0) {return -1;}
	strlwr(mshortstring);strlwr(mlongstring);
	r = 0;
	int vk;
	bool isok;
	//longstring: blablubb - 8
	//shortstring: abl - 3
	while (r < strlen(mlongstring) - (strlen(mshortstring) - 1)) {// 8 - 2
		if (mlongstring[r] == mshortstring[0]) {//r = 2, blABLubb Abl
			vk = r;isok = false;
			while (vk < strlen(mlongstring) && vk - r < strlen(mshortstring)) {
				if (mlongstring[vk] != mshortstring[vk - r]) {break;}
				if (mlongstring[vk] == mshortstring[vk - r] && vk - r == strlen(mshortstring) - 1) {isok = true;break;}
				vk += 1;
			}
			if (isok == true) {return 0;}
		}
		r += 1;
	}
	return -1;
}
int charpos(const unsigned char* stringle,unsigned char zeichen)//returns the position of a char in a string
{
	unsigned int z;
	z = 0;
	if (strlen(stringle) > 0) {
		while (z < strlen(stringle)) {
			if (stringle[z] == 0) {
				return -1;
			}
			if (stringle[z] == zeichen) {
				return z;
			}
			z += 1;
		}
		return -1;
	}else{
		return -1;
	}
}
int charposfromright(const unsigned char* stringle,char zeichen) //returns the position of a char in a string
{
	unsigned int z;
	z = strlen(stringle);
	if (strlen(stringle) > 0) {
		while (z > 0) {
			z -= 1;
			if (stringle[z] == zeichen) {
				return z;
			}
		}
		return -1;
	}else{return -1;}
}
int allbehindchar(unsigned char zeichen,unsigned char* target,const unsigned char* str) {
	int r;
	r = charpos(str,zeichen);
	if (r <= -1) {
		strcpy(target,"\0");
		return;
	}else{
		if (r < strlen(str) - 1) {
			strcpy(target,str);
			cut(target,r + 1);
		}else{
			strcpy(target,"\0");
		}
	}
}
char Bmystringle[PROCESSLENGTH];//defined for char remove at beginning
char Bmystringle2[PROCESSLENGTH];//defined for charS remove at beginning
const unsigned char* char_removeatbeginning(const unsigned char* stringle) //returns a string pointer, doesn't modify the original string
{
	int r;
	r = strlen(stringle);
	if (r > PROCESSLENGTH - 1) {r = PROCESSLENGTH - 1;}
	unsigned int z;
	z = 0;
	if (strlen(stringle) > 1) {
		strncpy(Bmystringle,stringle,PROCESSLENGTH - 1);
		Bmystringle[r] = 0;
		while (z < strlen(stringle) - 1) {
			Bmystringle[z] = stringle[z + 1];
			z += 1;
		}
		Bmystringle[strlen(stringle) - 1] = 0;
		return Bmystringle;
	}else{
		strcpy(Bmystringle,"");
		return Bmystringle;
	}
}
void cutFAST(char* vstring,int count,int maxlen)//THIS is the FAST version for BIG buffers!
{
	int r = 0;
	while (r < maxlen-(count)) {
		vstring[r] = vstring[r + count];
		r += 1;
	}
	vstring[maxlen-(count)] = 0;
}
int cut(unsigned char* vstring, int count) //REWRITTEN to use cutFAST() in 0.4-prealpha2
{
	if (count <= 0) {return;}
	int r = strlen(vstring);
	if (count >= r) {strcpy(vstring,"");return;}
	cutFAST(vstring, count, r+1);//make sure to include nullterminator, too
}
/*int cut(unsigned char* vstring,int count) {//modifies the given string, returns nothing <!-- OLD VERSION -->
 s t*rcpy(vstring,chars_removeatbeginning(count,vstring));
 }*/
bool strstw(const unsigned char* bigstring,const unsigned char* startstring) //strstw = string starts with//
{
	unsigned char thelongstring[PROCESSLENGTH];
	strncpy(thelongstring,bigstring,PROCESSLENGTH - 1);
	int r = 0;
	if (strlen(thelongstring) <= 0) {
		if (strlen(startstring) > 0) {
			return false;
		}else{return true;}
	}
	if (strlen(startstring) <= 0) {return true;}
	if (strlen(thelongstring) < strlen(startstring)) {
		return false;
	}
	if (strlen(thelongstring) > strlen(startstring)) {
		r = strlen(startstring);
		thelongstring[r] = 0;
		if (strcasecmp(thelongstring,startstring) == 0) {
			return true;
		}else{return false;}
	}else{
		if (strcasecmp(thelongstring,startstring) == 0) {return true;}else{return false;}
	}
}
int strendswith(const unsigned char* bigstring, const unsigned char* endstring) {
	if (strlen(bigstring) < strlen(endstring)) {return -1;}
	if (strlen(bigstring) == strlen(endstring)) {
		if (strcasecmp(bigstring,endstring) == 0) {
			return 0;
		}else{
			return -1;
		}
	}
	unsigned char* buf = alloca(strlen(bigstring)+1);
	strcpy(buf,bigstring);
	cut(buf,strlen(bigstring)-strlen(endstring));
	//printf("comparing %s and %s\n",buf,endstring);
	if (strcasecmp(buf,endstring) == 0) {
		return 0;
	}else{
		return -1;
	}
}
bool onlyspaces(const unsigned char* vstring) {
	int r = 0;
	while (vstring[r] != 0 && r < 1000) {
		if (vstring[r] != 32 && vstring[r] != 9) {return false;}
		r += 1;
	}
	return true;
}
void trimright(unsigned char* vstring) {
	if (onlyspaces(vstring) == true) {strcpy(vstring,"");return;}
	if (vstring == NULL) {return;}
	if (strlen(vstring) < 1) {return;}
	while (strlen(vstring) > 1 && (vstring[strlen(vstring) - 1] == 32 || vstring[strlen(vstring) - 1] == 9)) {
		vstring[strlen(vstring) - 1] = 0;//cut last char because it is a space char
	}
}
void trimleft(unsigned char* vstring) {
	if (onlyspaces(vstring) == true) {strcpy(vstring,"");return;}
	if (vstring == NULL) {return;}
	if (strlen(vstring) < 1) {return;}
	while (strstw(vstring," ") == true || vstring[0] == 9) {
		cut(vstring,1);
	}
}
int cutonfirstspace(unsigned char* vstring) {
	if (strcasecmp(vstring," ") == 0) {strcpy(vstring,"");return;}
	if (strlen(vstring) == 1) {return;}
	if (onlyspaces(vstring) == true) {strcpy(vstring,"");return;}
	if (vstring == NULL) {return;}
	if (strlen(vstring) < 1) {return;}
	int fcount2;
	fcount2 = 0;
	if (strlen(vstring) <= 0) {return;}
	while (fcount2 < strlen(vstring)) {
		if (vstring[fcount2] == 32 || vstring[fcount2] == 9) {
			vstring[fcount2] = 0;
			return;
		}
		fcount2 += 1;
	}
}
int allbeforechar(unsigned char zeichen,unsigned char* target,const unsigned char* str) {
	int r;
	r = charpos(str,zeichen);
	if (r <= -1) {
		strcpy(target,str);
		return;
	}else{
		if (r > 0) {
			strncpy(target,str,r);
			target[r] = 0;
			return;
		}else{
			strcpy(target,"");
			return;
		}
	}
}
const unsigned char* replacechar(const unsigned char* vstring,int originalchar,int targetchar)//returns a string pointer
{
	int r;
	if (strlen(vstring) <= 0) {strcpy(Bmystringle,"");return Bmystringle;}
	r = strlen(vstring);
	if (r > PROCESSLENGTH - 1) {r = PROCESSLENGTH - 1;}
	strncpy(Bmystringle,vstring,r);
	Bmystringle[r] = 0;
	int k;
	int z;
	k = 0;
	while (k < r) {
		if (Bmystringle[k] == originalchar) {
			if (targetchar != 0) {//that means I want to replace a char (if the target char is not empty)
				Bmystringle[k] = targetchar;
			}else{//the target char is empty, that means I want to remove a char out of the string, replace it with nothing
				if (k < r - 1) {//the char that should be removed has been found, and its not at the end => move everything behind it one step towards it
					z = k;
					while (z < r - 1) {//everything till the second-to-last-char one step to the start
						Bmystringle[z] = Bmystringle[z + 1];
						z += 1;
					}
					r -= 1;//the string should now be one char shorter
					Bmystringle[r] = 0;//the second-to-last-char gets the new last-char (r is one smaller, so its the second-to-last-char now)
					k -= 1;//we just moved everything from the current position one step to the start, so we need to decrease the loop var too, because it shouldnt raise (it raises at the end of the loop, this way it gets again the same value, and the char at this position, which is now a new one because of the moving, gets proceeded again)
				}else{//the char that should be removed is at the end - just set it to 0 to remove it and return the result
					Bmystringle[k] = 0;
					return Bmystringle;
				}
			}
		}
		k += 1;
	}
	return Bmystringle;
}

